//by Deathfly
//reflect magic
package data.scripts.weapons;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.CollisionClass;

import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.DamagingProjectileAPI;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.OnHitEffectPlugin;
import com.fs.starfarer.api.util.IntervalUtil;
import com.fs.starfarer.combat.entities.Missile;
import com.fs.starfarer.combat.entities.MovingRay;
import java.awt.Color;
import java.lang.reflect.Field;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.lazywizard.lazylib.MathUtils;
import org.lazywizard.lazylib.combat.entities.SimpleEntity;

public class NeutPulsarOnHitEffect implements OnHitEffectPlugin {

    private float timer = 0.0001f;
    private Field f;
    private IntervalUtil interval = new IntervalUtil(0.01f, 0.01f);
    private float damage = 0;

    @Override
    public void onHit(DamagingProjectileAPI projectile, CombatEntityAPI target,
            Vector2f point, boolean shieldHit, CombatEngineAPI engine) {
        if (timer > 0) {
            if (f == null) {
                try {
                    f = projectile.getClass().getDeclaredField("didDamage");
                    f.setAccessible(true);
                    f.setBoolean(projectile, false);
                } catch (NoSuchFieldException | SecurityException | IllegalArgumentException | IllegalAccessException ex) {
                    Logger.getLogger(NeutPulsarOnHitEffect.class.getName()).log(Level.SEVERE, null, ex);
                }
                damage = projectile.getDamageAmount();
            } else {
                try {
                    f.setBoolean(projectile, false);
                } catch (IllegalArgumentException | IllegalAccessException ex) {
                    Logger.getLogger(NeutPulsarOnHitEffect.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
                                MovingRay mr = (MovingRay) projectile;
                    mr.advance(Global.getCombatEngine().getElapsedInLastFrame());
                    mr.addPierced(CollisionClass.MISSILE_FF);
                    mr.addPierced(CollisionClass.MISSILE_NO_FF);
            if (target instanceof MissileAPI) {
                if (target.getHitpoints() < projectile.getDamageAmount()) {
                    damage -= target.getHitpoints();
//                    projectile.setDamageAmount(damage);
//                     engine.applyDamage(target, point, projectile.getDamageAmount(), DamageType.ENERGY, timer,
//                            true, false, projectile.getSource());
//                    target.setCollisionClass(CollisionClass.NONE);

//                    engine.addSmoothParticle(projectile.getLocation(), new Vector2f(0,0), 5, 4, 3, Color.yellow);

                } else {
                    try {
                        f.setBoolean(projectile, true);
                    } catch (IllegalArgumentException | IllegalAccessException ex) {
                        Logger.getLogger(NeutPulsarOnHitEffect.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            } else {
//                MovingRay mr = (MovingRay) projectile;
                float amount = Global.getCombatEngine().getElapsedInLastFrame();
                interval.advance(amount);
                if (interval.intervalElapsed()) {
                    projectile.setDamageAmount(damage * 0.01f);
//                    SimpleEntity dir = new SimpleEntity(MathUtils.getRandomPointOnCircumference(point, MathUtils.getRandomNumberInRange(40f, 80f)));
//                    engine.spawnEmpArc(projectile.getSource(), point, dir, dir,
//                            DamageType.KINETIC,
//                            0,
//                            0, // emp 
//                            25f, // max range 
//                            "tachyon_lance_emp_impact",
//                            5F, // thickness
//                            new Color(217, 204, 0, 255),
//                            new Color(234, 80, 64, 255));
                } else {
                    projectile.setDamageAmount(1);
                }
                timer -= amount;
            }
        }
    }
}
